;============================================================
          !to "zoomer.prg" , CBM
;============================================================
init_msx = $1000
cnt_msx = $1003

tb_jump = $b900
startsp = tb_jump +$0100
;=========================

         *= $0801

;BASICLINE
         !byte $0B,$08,$90,$06,$9E,$32
         !byte $30,$34,$39,$00,$A0,$00

          SEI
          CLD
          LDX #$FF
          TXS

          LDA #$37
          STA $01


          LDA #$7F
          STA $DC0D
          STA $DD0D
          LDA $DC0D
          LDA $DD0D
          lda #$01
          sta $d01a
          lda #$ff
          sta $d012

          LDA #$3B
          STA $D011

          lda #$c8
          sta $d016
          lda #$18
          sta $d018

          lda #$80
          ldx #$00
          stx $d020
-
          sta $0400,x
          sta $0500,x
          sta $0600,x
          sta $06e8,x
          inx
          bne -
          lda #<irq
          sta $fffe
          lda #>irq
          sta $ffff

          lda #$00
          tax
          tay
          jsr init_msx


          lda #<nmiex
          sta $fffa
          lda #>nmiex
          sta $fffb

          lda #1
          sta $dd05
          sta $dd04

          LDA #$35
          STA $01
          inc $d019

          lda #$11
          sta $dd0e
          lda #$81
          sta $dd0d

          cli
mainloop
          lda #$40
          sta rewr+2
          lsr
          tax
          sta rewr+5

          ldy #0

rewr      lda $1000,y
          sta $1000,y
          iny
          bne rewr
          inc rewr+2
          inc rewr+5
          dex
          bne rewr

          jsr zoomer
          lda #$35
          sta $01
          jmp mainloop
;========
irq
;===
          pha
          tya
          pha
          txa
          pha
          lda $01
          pha
          lda #$35
          sta $01

          jsr cnt_msx
          inc $d019

          pla
          sta $01
          pla
          tax
          pla
          tay
          pla
nmiex     rti

;==============
zoomer
jsr createspd
;********************************
secloop
          lda poztab
          and #$1f
          tax
          ldy tabxst,x
          jsr toright
          jsr toleft
;=====
          lda poztab
          and #$1f
          tax
          lda tabyst,x
          asl
          asl
          tay
          beq *+5
          jsr tobottom
;=====
          tya
          beq *+5
          jsr totop

          inc poztab
          lda poztab
          cmp #$e8
          bne secloop
          rts
;========
;=============
poztab
!byte 0,0
;====
tabxst
!byte 0,8,16,24,32,40,48,56,64,72,80,88,96,104,112,120
!byte 0,8,16,24,32,40,48,56,64,72,80,88,96,104,112,120
tabyst
!byte 0,0,25,0,24,0,22,0,22,0,21,0,20,0,19,0
!byte 18,0,17,0,16,15,14,13,12,11,10,9,8,7,6,5
;============

;============
toright       jmp *
toleft        jmp *
tobottom      jmp *
totop         jmp *
;============
createspd
          lda #$34
          sta $01

          ldy #0
          ldx #$00


-         txa
          sta tb_jump,y
          iny
          tya
          and #7
          bne -
          txa
          clc
          adc #3
          tax
          cpy #0
          bne -



          jsr make_right
          jsr make_left
          jsr make_totop
          jmp make_tobottom
;===========================
make_right


          lda #<startsp
          sta storedata+1
          lda #>startsp
          sta storedata+2
          lda #<$2098
          sta vect1
          lda #>$2098
          sta vect1+1

          lda storedata+1
          sta toright+1
          lda storedata+2
          sta toright+2


          ldy #25
          jsr copy_1seq
          dey
          bne *-4
          jmp storerts
;====
copy_1seq
          ldx #0
-         lda f_seq,x
          jsr storedata
          inx
          cpx #14
          bne -
          lda storedata+2
          pha
          lda storedata+1
          clc
          adc #3
          jsr storedata
          pla
          adc #0
          jsr storedata
          lda f_seq+2,x
          jsr storedata
          lda f_seq+3,x
          jsr storedata
          lda vect1
          sta vect2
          clc
          adc #$40
          sta vect1
          lda vect1+1
          sta vect2+1
          adc #1
          sta vect1+1

          ldx #20
-         lda vect2-1
          jsr storedata
          lda vect2
          clc
          adc #8
          sta vect2
          jsr storedata
          lda vect2+1
          adc #0
          sta vect2+1
          jsr storedata
          dex
          bne -
-         lda vect2+2,x
          jsr storedata
          inx
          cpx #5
          bne -
          rts
;===
f_seq
          ldx #7
          tya
          ora #7
          tay

vect1 = *+1
          lda $2098+ 0*320,y
          lsr
          lda tb_jump,y
          sta *+4
          bne *
vect2 = *+1
          ror $20a0,x
          dey
          dex
          bpl *-74
          iny
;======
storerts  lda #$60
storedata
          sta startsp
          inc storedata+1
          bne *+5
          inc storedata+2
          rts
;======
make_left
          lda storedata+1
          sta toleft+1
          lda storedata+2
          sta toleft+2

          lda #<$20a0
          sta vect1a
          lda #>$20a0
          sta vect1a+1
          ldy #0
          jsr copy_2seq
          iny
          cpy #25
          bne *-6
          jmp storerts
;====
copy_2seq
          ldx #0
-         lda s_seq,x
          jsr storedata
          inx
          cpx #7
          bne -
          tya
          and #3
          tax
          lda tb_adclo,x
          jsr storedata
          lda s_seq+8
          jsr storedata

          lda storedata+2
          pha
          lda storedata+1
          clc
          adc tab_ad,x
          jsr storedata
          pla
          adc #0
          jsr storedata
          cpx #2
          bcc +

          lda s_seq+11
          jsr storedata
          lda vect1a+1
          sec
          sbc #1
          jsr storedata
          lda s_seq+13
          jsr storedata
          lda s_seq+14
          jsr storedata
          lda s_seq+15
          jsr storedata

          lda storedata+2
          pha
          lda storedata+1
          clc
          adc #4
          jsr storedata
          pla
          adc #0
          jsr storedata
+
          ldx #0
-         lda vect1a-1,x
          jsr storedata
          inx
          cpx #8
          bne -

          lda storedata+2
          pha
          lda storedata+1
          clc
          adc #3
          jsr storedata
          pla
          adc #0
          jsr storedata

          lda s_seq+28
          jsr storedata
          lda s_seq+29
          jsr storedata


          lda vect1a
          sta vect2a
          clc
          adc #$40
          sta vect1a
          lda vect1a+1
          sta vect2a+1
          adc #1
          sta vect1a+1

          ldx #20
-         lda vect2a-1
          jsr storedata
          lda vect2a
          sec
          sbc #8
          sta vect2a
          jsr storedata
          lda vect2a+1
          sbc #0
          sta vect2a+1
          jsr storedata
          dex
          bne -

-         lda vect2a+2,x
          jsr storedata
          inx
          cpx #3
          bne -
          rts
;===
s_seq
          ldx #7
          tya
          eor #$ff
          sec
          adc #$20
          sta $1111
          lda #$22
          adc #$00
          sta $1112

vect1a = *+1
          lda $2098+ 0*320,x
          asl
          lda tb_jump,y
          sta *+4
          bne *
vect2a = *+1
          rol $20a0,x
          dex
          bpl *-73
          iny
;======
tab_ad
          !byte 3,3,10,10
;===
tb_adclo
          !byte $a0,$e0,$20,$60
;===
;======
make_totop

          lda storedata+1
          sta totop+1
          lda storedata+2
          sta totop+2
          lda #<$2001
          sta vect1b
          lda #>$2001
          sta vect1b+1
          lda #7
          sta t_seq+3

          ldy #0
          jsr copy_3seq
          iny
          cpy #13
          bne *-6
          jmp storerts
;====
copy_3seq
          ldx #0
-         lda t_seq,x
          jsr storedata
          inx
          cpx #14
          bne -
          lda storedata+2
          pha
          lda storedata+1
          clc
          adc #246
          jsr storedata
          pla
          adc #0
          jsr storedata
          lda t_seq+16
          jsr storedata
          lda t_seq+17
          jsr storedata

          ldx #40

-         lda t_seq+18
          jsr storedata
          lda vect1b
          jsr storedata
          lda vect1b+1
          jsr storedata
          lda t_seq+21
          jsr storedata
          lda vect1b
          sec
          sbc #1
          jsr storedata
          lda vect1b+1
          sbc #$00
          jsr storedata
          lda vect1b
          clc
          adc #8
          sta vect1b
          lda vect1b+1
          adc #0
          sta vect1b+1
          dex
          bne -

          lda tss,x
          jsr storedata
          inx
          cpx #6
          bne *-9
          lda storedata+2
          pha
          lda storedata+1
          sec
          sbc #246
          jsr storedata
          pla
          sbc #0
          jsr storedata
          lda tss2
          jsr storedata
          lda t_seq+3
          clc
          adc #1
          jsr storedata
          ldx #0
          lda tss3,x
          jsr storedata
          inx
          cpx #3
          bne *-9

          lda vect1b
          sec
          sbc #1
          sta vect2b
          lda vect1b+1
          sbc #0
          sta vect2b+1

          ldx #40
-         lda tss4
          jsr storedata
          lda vect2b
          jsr storedata
          lda vect2b+1
          jsr storedata
          lda tss4+3
          jsr storedata
          lda vect2b
          sec
          sbc #$39
          jsr storedata
          lda vect2b+1
          sbc #$01
          jsr storedata
          lda vect2b
          clc
          adc #8
          sta vect2b
          lda vect2b+1
          adc #0
          sta vect2b+1
          dex
          bne -

          lda tss5
          jsr storedata
          lda t_seq+3
          clc
          adc #2
          jsr storedata
          adc #6
          sta t_seq+3

          ldx #0
          lda tss6,x
          jsr storedata
          inx
          cpx #3
          bne *-9



          rts


;===
t_seq
          lda #7
          cpy #7
          bcs *+9
          tya
          and #7
          bne *+4
          lda #1
          sta $1111
          ldx #0
-
vect1b = *+1
     lda $2001,x
     sta $2000,x

tss
     inx

     cpx #0
     beq *+5
     jmp -
tss2
     cpy #8
tss3
     bcs *+3
     rts

tss4
vect2b =*+1
     lda $1111
     sta $1111
tss5
     cpy #9
tss6
     bcs *+3
     rts
;======
;======
make_tobottom

          lda storedata+1
          sta tobottom+1
          lda storedata+2
          sta tobottom+2

          lda #<($2000 + 24*320)
          sta vect1c
          lda #>($2000 + 24*320)
          sta vect1c+1
          lda #7
          sta forth_seq+5

          ldy #0
          jsr copy_4seq
          iny
          cpy #13
          bne *-6
          jmp storerts
;====
copy_4seq
          ldx #0
-         lda forth_seq,x
          jsr storedata
          inx
          cpx #16
          bne -
          lda storedata+2
          pha
          lda storedata+1
          clc
          adc #244
          jsr storedata
          pla
          adc #0
          jsr storedata


          ldx #40

-         lda forth_seq+18
          jsr storedata
          lda vect1c
          jsr storedata
          lda vect1c+1
          jsr storedata
          lda forth_seq+21
          jsr storedata
          lda vect1c
          clc
          adc #1
          jsr storedata
          lda vect1c+1
          adc #$00
          jsr storedata
          lda vect1c
          clc
          adc #8
          sta vect1c
          lda vect1c+1
          adc #0
          sta vect1c+1
          dex
          bne -

          lda tss_0,x
          jsr storedata
          inx
          cpx #6
          bne *-9
          lda storedata+2
          pha
          lda storedata+1
          sec
          sbc #246
          jsr storedata
          pla
          sbc #0
          jsr storedata
          lda tss2a
          jsr storedata
          lda forth_seq+5
          clc
          adc #1
          jsr storedata
          ldx #0
          lda tss3a,x
          jsr storedata
          inx
          cpx #3
          bne *-9

          lda vect1c
          sec
          sbc #$79
          sta vect2c
          lda vect1c+1
          sbc #2
          sta vect2c+1



          ldx #40
-         lda tss4a
          jsr storedata
          lda vect2c
          jsr storedata
          lda vect2c+1
          jsr storedata
          lda tss4a+3
          jsr storedata
          lda vect2c
          clc
          adc #$39
          jsr storedata
          lda vect2c+1
          adc #$01
          jsr storedata
          lda vect2c
          clc
          adc #8
          sta vect2c
          lda vect2c+1
          adc #0
          sta vect2c+1
          dex
          bne -

          lda tss5a
          jsr storedata
          lda forth_seq+5
          clc
          adc #2
          jsr storedata
          adc #6
          sta forth_seq+5

          ldx #0
          lda tss6a,x
          jsr storedata
          inx
          cpx #3
          bne *-9

          lda vect1c
          sec
          sbc #$80
          sta vect1c

          lda vect1c+1
          sbc #2
          sta vect1c+1

          rts


;===
forth_seq
          ldx #6
          lda #$ff
          cpy #7 +0*8
          bcs +
          tya
          and #7
          eor #7
          sbc #0
+         sta $1111
-
vect1c = *+1
     lda $2000 + 24*320,x
     sta $2001 + 24*320,x

tss_0
     dex
     cpx #0
     beq *+5
     jmp -
tss2a
     cpy #8
tss3a
     bcs *+3
     rts

tss4a
vect2c =*+1
     lda $1111
     sta $1111
tss5a
     cpy #9
tss6a
     bcs *+3
     rts
;======

eofcode
;=========================
*=$1000
!binary "fogymsx.prg",,2
;==========================
*=$4000
!binary "fogyish.bmpc64",,2
;=========================
